from picamera import PiCamera
import RPi.GPIO as GPIO
import time
import cloudsight
from PIL import Image, ImageDraw, ImageFont
import uuid
import re
import pygame
import unirest
import socket
REMOTE_SERVER = "www.google.com"
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
GPIO.setup(18,GPIO.OUT)
GPIO.setup(17,GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(27,GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(22,GPIO.IN, pull_up_down=GPIO.PUD_UP)
camera = PiCamera()
camera.framerate =10                                                           
camera.rotation = 90
pygame.init()
def is_connected():
  try:
    # see if we can resolve the host name -- tells us if there is
    # a DNS listening
    host = socket.gethostbyname(REMOTE_SERVER)
    # connect to the host -- tells us if the host is actually
    # reachable
    s = socket.create_connection((host, 80), 2)
    return True
  except:
     pass
  return False
print is_connected()
while True:
    time.sleep(0.2)
    input_state17 = GPIO.input(17)
    input_state22 = GPIO.input(22)
    input_state27 = GPIO.input(27)
    if input_state17 == False:#Regular Pictures
        print('17 Button Pressed')
        print "LED on"
        GPIO.output(18,GPIO.HIGH)
        time.sleep(1)
        print "LED off"
        GPIO.output(18,GPIO.LOW)
        camera.resolution = (2592,1936)
        print('Button Pressed, Preview Mode')
        filename = str(uuid.uuid4())  
        camera.start_preview()
        time.sleep(6)
        camera.capture("/home/pi/Pictures/Image_"+filename+".jpg")
        camera.stop_preview()
        time.sleep(1)
    if input_state22 == False:# Image OCR Recognition
        print('22 Button Pressed')
        print "LED on"
        GPIO.output(18,GPIO.HIGH)
        time.sleep(1)
        print "LED off"
        GPIO.output(18,GPIO.LOW)
        camera.resolution = (720,480)

        print('Button Pressed, Preview Mode')
        filename = str(uuid.uuid4())  
        
        camera.start_preview()
        time.sleep(4)
        camera.capture("/home/pi/ImageOCR/image.jpg")
        camera.stop_preview()
        time.sleep(1)
        if is_connected()  == True:
#=========================================================        
            response = unirest.post("https://api.ocr.space/parse/image",
              headers={
                'apikey': 'helloworld',
        
        
              },
              params={
                'apikey': 'helloworld',
                "file": open ("/home/pi/ImageOCR/image.jpg")
              }
            )
            time.sleep(1)
            print" after sleep"
            print str(response.code)
            print"response.code"
            print str(response.headers)
            print" response.headers"
            print str(response.body)
            x = str(response.body)
            print" response.body"
            import re
            p = re.compile(ur'u\'ParsedText\': u\'(?s)(.*), u\'FileParseExitCode')
            test_str = u"{u'ErrorDetails': None, u'ErrorMessage': None, u'OCRExitCode': 1, u'ParsedResults': [{u'ParsedText': u'WHAT IF EVERYTHING \r\nWAS PINEAPPLE \r\nmem em aketuet \r\n', u'FileParseExitCode': 1, u'ErrorMessage': u'', u'TextOverlay': {u'HasOverlay': False, u'Lines': None, u'Message': u'Overlay is not required'}, u'ErrorDetails': u''}], u'IsErroredOnProcessing': False, u'ProcessingTimeInMilliseconds': u'2062'}"

            t = re.search(p, x)
            t = t.group(1)
            print t
        if is_connected()  == False:
            t = "!No Connection!"
#===============================================================
        image = Image.open("/home/pi/ImageOCR/image.jpg")
        draw = ImageDraw.Draw(image)
        font = ImageFont.truetype("/usr/share/fonts/truetype/roboto/Roboto-Bold.ttf", 30, encoding="unic")
        draw.text((10,10), t,fill='#FFFFFF', font=font)
        image.save("/home/pi/ImageOCR/Image Recognition"+filename+".jpg")

        display_width = 720
        display_height = 480

        gameDisplay = pygame.display.set_mode((display_width,display_height))
        pygame.display.set_caption(t)

        black = (0,0,0)
        white = (255,255,255)

        clock = pygame.time.Clock()
        crashed = False
        carImg = pygame.image.load('/home/pi/ImageOCR/image.jpg')

        def car(x,y):
            gameDisplay.blit(carImg, (x,y))

        x = 0
        y = 0
        
       
        gameDisplay.fill(white)
        car(x,y)

        
        pygame.display.update()
        clock.tick(60)
        time.sleep(6)  
        pygame.quit()

    
    if input_state27 == False:
        print('27 Button Pressed')
        print "LED on"
        GPIO.output(18,GPIO.HIGH)
        time.sleep(1)
        print "LED off"
        GPIO.output(18,GPIO.LOW)
        camera.resolution = (720,480)
        print('Button Pressed, Preview Mode')
        filename = str(uuid.uuid4())  
        
        camera.start_preview()
        time.sleep(3)
        camera.capture("/home/pi/ImageRecognition/image.jpg")
        camera.stop_preview()
        time.sleep(3)
        if is_connected()  == True:
            auth = cloudsight.SimpleAuth('iRci9jk_Bym1nxf2LsLOBg')
            api = cloudsight.API(auth)
            with open('/home/pi/ImageRecognition/image.jpg', 'rb') as f:
                response = api.image_request(f, '/home/pi/ImageRecognition/image.jpg',{'image_request[locale]': 'en-US',})


            status = api.image_response(response['token'])
            print status
            if status['status'] != cloudsight.STATUS_NOT_COMPLETED:
                #Done!
                print "lol"
                pass

            status =api.wait(response['token'], timeout=25)#25
            print status
            stringy = str(status)
            print "DONE"
            t = re.search('(?<=abc)def','abcdef')
            t = t.group(0)

            import re
            p = re.compile(ur'name\': u\'(?s)(.*)\', u\'ttl')
            x = re.search(p, stringy)
            x = x.group(1)
     

            print t
            print x
        if is_connected()  == False:
            x="!No Connection!"
            
        image = Image.open("/home/pi/ImageRecognition/image.jpg")
        draw = ImageDraw.Draw(image)
        font = ImageFont.truetype("/usr/share/fonts/truetype/roboto/Roboto-Bold.ttf", 30, encoding="unic")
        draw.text((10,10), x,fill='#FFFFFF', font=font)
        image.save("/home/pi/ImageRecognition/Image Recognition"+filename+".jpg")

        display_width = 720
        display_height = 480

        gameDisplay = pygame.display.set_mode((display_width,display_height))
        pygame.display.set_caption(x)

        black = (0,0,0)
        white = (255,255,255)

        clock = pygame.time.Clock()
        crashed = False
        carImg = pygame.image.load('/home/pi/ImageRecognition/image.jpg')

        def car(x,y):
            gameDisplay.blit(carImg, (x,y))

        x = 0
        y = 0
        
       
        gameDisplay.fill(white)
        car(x,y)

        
        pygame.display.update()
        clock.tick(60)
        time.sleep(6)  
        pygame.quit()
